/*
    Copyright (c)
    1987, 1988, 1989, 1990, 1991, 1992, 1993  Electrotechnical Laboratory 

    Permission to use, copy, modify, and distribute this software
    and its documentation for any purpose is hereby granted without fee,
    provided that the above copyright notice and this permission notice
    appear in all versions of this software.

    Author: Yutaka Sato     Electrotechnical Laboratory
                            <ysato@etl.go.jo>
 */

/*######################################################################*
 *									*
 *		Onew for Nihongo text Entry with Wnn			*
 *									*
 *######################################################################*/
#define STATIC static

#include <stdio.h>
#include <ctype.h>

typedef unsigned short wchar;

#include "onew.h"

extern RkEngine *RomkanP();
#define RP RomkanP()
#define IR				romkan_select()
#define ONEWromkan_name()		(IR,RP->rk_name)
#define ONEWromkan_ready()		(IR,(*RP->rk_ready)())
#define ONEWromkan_modesw(mode)		(IR,(*RP->rk_modesw)(mode))
#define ONEWromkan_clear()		(IR,(*RP->rk_gotch)())
#define ONEWromkan_getc()		(IR,(*RP->rk_getc)())
#define ONEWromkan_next()		(IR,(*RP->rk_next)())
#define ONEWromkan_dispmode()		(IR,(*RP->rk_dispmode)())
#define ONEWromkan_gotch(ch)		(IR,(*RP->rk_gotch)(ch))

extern KkEngine *KanakanP();
#define KP KanakanP()
#define IK				kanakan_select()
#define ONEWkanakan_name()		(IK,KP->kk_name)
#define ONEWkanakan_ready()		(IK,(*KP->kk_ready)())
#define ONEWkanakan(c,y)		(IK,(*KP->kk_kanakan)(c,y))
#define ONEWkanakan_freqsave()		(IK,(*KP->kk_freqsave)())
#define ONEWkanakan_kouho()		(IK,KP->kk_kouho)
#define ONEWbunsetu_next(cur,inc)	(IK,(*KP->kk_next)(cur,inc))
#define ONEWbunsetu_expand(a,b,c)	(IK,(*KP->kk_expand)(a,b,c))
#define ONEWbunsetu_shrink(a,b,c)	(IK,(*KP->kk_shrink)(a,b,c))
#define ONEWjisyo_touroku(a,b,c,d)	(IK,(*KP->kk_touroku)(a,b,c,d))
#define ONEWjisyo_hinshi(hl)		(IK,(*KP->kk_hinshi)(hl))

static romkan_ready(){
	romkan_select();
	return ONEWromkan_ready();
}
static kanakan_ready(){
	kanakan_select();
	return ONEWkanakan_ready();
}

/*######################################################################*/
#define KU_SIZE	0x60

int ONEW_DEBUG;
int ONEW_MSGHOLD;

int ONEW_RK_THRU;
int ONEW_NN_THRU;
int ONEW_THRUSYMS_ON;
int ONEW_IN_ISO2022;

int ONEW_MODE_SWITCHER	= Cntl('\\');
int ONEW_ROMKAN_TOGGLE	= Cntl('@');
int ONEW_KANA_TOGGLE	= Cntl('K');
int ONEW_ZENKAKU_TOGGLE	= Cntl('L');
int ONEW_RKKSERV_SW	= 'Q';
int THRU_NEXTCHAR	= Cntl('V');
int ONEW_HENKAN_START	= Cntl('W');
int THRUSYMS_SETUP	= Cntl('@');
int THRUSYMS_TOGGLE	= Cntl('^');

static int KK_OPDICT	= 'x';

#define MODE_SWITCHER	ONEW_MODE_SWITCHER
#define ZENKAKU_TOGGLE	ONEW_ZENKAKU_TOGGLE
#define KANA_TOGGLE	ONEW_KANA_TOGGLE
#define ROMKAN_TOGGLE	ONEW_ROMKAN_TOGGLE

char *ONEW_THRUSYMS	= "[ -,.-@\\^-`{-~]";
char  ONEW_THRUSYMA[256]; /* THRUSYMS mapped to the array */
char *ONEW_HENKANKEYS	= "[ ]";
char  ONEW_HENKANKEYA[256];

#define IS_NOINS_HENKANKEY(ch)	(ch == ONEW_HENKAN_START || ch == STD_HENKAN)
#define IS_INS_HENKANKEY(ch)	(ch && ONEW_HENKANKEYA[ch])
#define IS_HENKANKEY(ch)	(IS_NOINS_HENKANKEY(ch)||IS_INS_HENKANKEY(ch))
#define LET_IT_THRU(ch)		(ONEW_THRUSYMS_ON && ONEW_THRUSYMA[ch])

int ONEW_INCHAR_WIDTH = 1;
int ONEW_INCHAR_NTH = 0;
int ONEW_ESC_TIMEOUT = 300;

/* internally generated commands */
#define ESCESC			Cntl(']')
#define KAKUTEI			Cntl('_')
#define THRU_NEXTCHAR_I		Cntl('Z')
#define SYNC_CHAR_I		0xFF

#define ONEW_CONT	 0
#define ONEW_EXIT	(-1)
#define ONEW_LOOP	(-2)

#define CONT	ONEW_CONT
#define EXIT	ONEW_EXIT
#define LOOP	ONEW_LOOP


static int select_mode;
onew_kanakancom( ctx,comch,bunsetux,kouhox,candn,kep,alts )
    int *bunsetux,*kouhox;
{   int rc = CONT;
    int bi,ai;

    bi = *bunsetux; ai = *kouhox;

    if( comch == ROMKAN_TOGGLE ){
        romkan_toggle();				rc=EXIT;
    }else
    if( comch == KK_OPDICT ){
			clr_keyinQ();			rc=EXIT;
    }else
    switch( comch ){
	case Cntl('J'):
	case Cntl('M'):					rc=EXIT;break;
	default:	enq_keyinQ(comch);		rc=EXIT;break;

	case DEL_CH:
	case BS_CH:
	case 'Q':
	case 'q':
	case ESC_CH:	clr_keyinQ();			rc=EXIT;break;

	case ' ':
	case Cntl('N'): ai = ai + 1;			rc=CONT;break;
	case Cntl('P'): ai = ai - 1;			rc=CONT;break;
	case Cntl('T'): ai = 0;				rc=CONT;break;
	case Cntl('W'):
	case Cntl('G'):
	     select_mode = 1;
	     putmode(ONEW_mode_ichiran,"");
	     ai = Onew_list_sentaku(0,0,ONEWkanakan_kouho(),alts,candn,10,0);
	     select_mode = 0;
							rc=CONT;break;

	case Cntl('F'): bi = ONEWbunsetu_next(bi, 1);	rc=LOOP;break;
	case Cntl('B'): bi = ONEWbunsetu_next(bi,-1);	rc=LOOP;break;
	case Cntl('A'): bi = ONEWbunsetu_next(-1, 1);	rc=LOOP;break;

	case Cntl('I'): ONEWbunsetu_shrink(ctx,kep,bi);	rc=LOOP;break;
	case Cntl('O'): ONEWbunsetu_expand(ctx,kep,bi);	rc=LOOP;break;
/*
	case Cntl('D'): ONEWbunsetu_delete(ctx,bi);	rc=LOOP;break;
	case Cntl('X'): ONEWexternal_henkan(ctx,alts);	rc=CONT;break;
*/
    }
    *bunsetux = bi; *kouhox = ai;
    return rc;
}

/*######################################################################*
 *	SELECTION FROM CANDIDATES LIST					*
 *######################################################################*/
Onew_list_sentaku(label_func,error_func,get_kdata,arg,nkouho,blk,fromp)
	int (*label_func)();
	int (*error_func)();
	wchar *(*get_kdata)();
	int *fromp;
{	Linebuff label,buff,tmp,kdata1;
	int i,ncom,from,to,selected,BLK;
	int maxcol = ONEW_MESSAGE_COLS();
	char *LABEL;
	char *selch;

	LABEL = ONEW_KOUHO_LABEL;
	maxcol -= 10;
	from = fromp ? *fromp : 0;
	selected = 0;

	for(;;){
		buff[0] = 0;
		to = from;
		for(i = 0; LABEL[i] && ((from+i)<nkouho); i++,to++){
			if( (*get_kdata)(arg,to,kdata1) == 0 )
				continue;
			Onew_rmpadds(kdata1);

			if( kdata1[0] & 0x80 )
				sprintf(tmp," %c%2s ",LABEL[i],kdata1);
			else	sprintf(tmp,"%c.%2s ",LABEL[i],kdata1);

			if(0 < i && maxcol < (strlen(buff)+strlen(tmp))){
				to--;
				break;
			}
			strcat(buff,tmp);
		}
		if( label_func )
			(label_func)(label,from,to+1,nkouho);
		else	sprintf(label,"[%2d/%-2d]",to,nkouho);
		putmsg(1,"%s %*s",label,-maxcol,buff);

		ncom = OnewGetchar();
		if( selch = (char*)strchr(LABEL,ncom) ){
			if( fromp ) *fromp = from;
			selected = (int)selch-(int)LABEL + from;

			if( selected < 0 || nkouho <= selected ){
				putmsg(1," selected=[%x]%d ??",ncom,selected);
				ONEW_BEEP(2);
				selected = 0;
			}
			goto exit;
		}

		BLK = blk * 10;
		switch(ncom){
			case 'b':
			case Cntl('P'):{
				int len = 0;

				if( from <= 1 )
					from = nkouho;
				for( i = from-1; 0 <= i; i-- ){
					(*get_kdata)(arg,i,kdata1);
					len += 3+strlen(kdata1);
					if( maxcol < len ){
						i++;
						break;
					}
				}
				from = i;
			}					break;
			case ' ':
			case Cntl('N'): from = to + 1;		break;
			case Cntl('F'): from = from + 1;	break;
			case Cntl('B'): from = from - 1;	break;
			case Cntl('A'): from = 0;		break;
			case Cntl('E'): from = nkouho - 1;	break;

			case 'n': from = ((from+blk)/blk)*blk;	break;
			case 'p': from = ((from-blk)/blk)*blk;	break;
			case 'N': from = ((from+BLK)/BLK)*BLK;	break;
			case 'P': from = ((from-BLK)/BLK)*BLK;	break;

			default:
				if( error_func ){
					(*error_func)(ncom);
					break;
				}

			case 'q':
			case ESC_CH: goto exit;
		}
		if( from < 0 && (ncom == 'p' || ncom == 'P') )
			from = nkouho - 1;
		else{
			if((from < 0) || (nkouho <= from))
				from = 0;
		}
	}
exit:
	return selected;
}

/*######################################################################*
 *	ROMKAN SPECIAL MODE						*
 *######################################################################*/

static int get_ch1_asis; /* never interpret as command keys */

static int JisyoMode;
static int JisyoGetYomi;
static int JisyoGetKanji;	/* touroku string input mode */
static int JisyoGetKanjiFlush;
static int JisyoMassyou;

static mode_switches(){
	int com;

	get_ch1_asis = 1;
	if( Onew_inready(stdin,400*1000) == 0 )
		putmode(ONEW_mode_modeswitch,ONEW_menu_modeswitch);
	com = ONEW_getch0(1);
	get_ch1_asis = 0;

	switch(com){
		case '#': break;
		case 'a':
			JisyoGetYomi = 1;
			enq_keyinQ(ONEW_HENKAN_START);
			break;

		case 'k': katakana_toggle(); break;
		case 'n': ONEW_NN_THRU = !ONEW_NN_THRU; break;
		case 'q':
			ungetc(0,stdin);
			/* romkan_toggle(); */
			break;
		case '.':
		case '=': sym_thru_toggle(); break;
		case 'c': /* canna */ break;
		case 'w': /* wnn */ break;
		case 'r': switch_rkserv(); break;
		case 's': switch_kkserv(); break;
	}
}

/*######################################################################*
 *	ROMKAN INTERFACE						*
 *######################################################################*/
/* romkan mode mnemonics */
#define RK_HIRA		'h'
#define RK_KATA		'k'
#define RK_LARGE	'l'
#define RK_THRU		'@'
#define RK_OFF		'-'

static Linebuff rawc_inbuff;
enq_keyinQ(c){ return enq_strq(rawc_inbuff,c); }
ins_keyinQ(c){ return ins_strq(rawc_inbuff,c); }
deq_keyinQ(){  return deq_strq(rawc_inbuff);   }
clr_keyinQ(){  return clr_strq(rawc_inbuff);   }
ready_keyinQ(){ return rawc_inbuff[0] != 0; }

char *romkan_cmode();
ONEW_getch0(asis){
	int ch;

	ch = deq_keyinQ();
	if(ch == 0){
		if( !asis && !get_ch1_asis )
			putmode(romkan_cmode(),0);
		ch = OnewGetchar();
	}
	return ch;
}
ONEW_getch1(){
   int ch;

   for(;;){
	ch = ONEW_getch0(get_ch1_asis);
	if( get_ch1_asis )
		break;

	if( ch == ROMKAN_TOGGLE  ){ romkan_toggle(); break;		}else
	if( ch == MODE_SWITCHER  ){ romkan_modesw(); ch = 0; break;	}else
	if( ch == THRUSYMS_TOGGLE){ sym_thru_toggle();			}else 
	if( romkan_on() ){
		if( IS_HENKANKEY(ch) && !IS_NOINS_HENKANKEY(ch) )
			enq_keyinQ(ONEW_HENKAN_START);

		if( definedKanamode(ch) ){ continue;                    }else
		if( ch == KANA_TOGGLE   ){ katakana_toggle();  continue;}else
		if( ch == ZENKAKU_TOGGLE){ zenkaku_toggle();   continue;}else
		if( ch == DEL_CH )	 { ch = Cntl('H');              }else
		if( ch == ESC_CH )	 { ONEWromkan_clear();ch=ESCESC;}else
		if( in_kana_mode() ){
			if( LET_IT_THRU(ch) && !IS_NOINS_HENKANKEY(ch) ){
				thru_char1(ch);
				continue;
			}else
			if( ch == 'Q' ){
				switch_rkserv();
				ch = 0;/* let the current Romkan exit */
			}else
			if( ch == 'q' ){
				mode_switches();
				ch = 0;
			}else
			switch( ch ){
				case 'Z':
					ins_zenkaku_char1(0,0);
					continue;
	/*
				default:
					if( 'A' <= ch && ch <= 'Y' )
					if( katakana_toggle() ){
						enq_keyinQ(ch-('A'-'a'));
						continue;
					}
	*/
			}
		}
		break;
	}else	break;
    }
    return ch;
}

static IFUNC KanamodeSw[128];
static int kanamodes[16];
static int kanamodex;

static definedKanamode(ch)
	unsigned char ch;
{	IFUNC func;

	if( 128 <= ch )
		return 0;
	if( func = KanamodeSw[ch] )
		return (*func)(ch);
	return 0;
}
Onew_defineKanamode(mode,ch,func)
	IFUNC func;
{
	kanamodes[kanamodex++] = mode;
	KanamodeSw[ch] = func;
}


static romkan_modesw(){
	int cmode;

	cmode = ONEW_getch1();
	romkan_mode_switch(cmode);
}
static thru_char1(ch){
	ins_keyinQ(ch);
	ins_keyinQ(THRU_NEXTCHAR_I);
}
ins_zenkaku_char1(ch,kakutei)
{
	char buf[8],*bp;

	if( ch == 0 ){
		int omode;
		omode = ONEW_kanamode;
		ONEW_kanamode = RK_ZENKAKU;
		putmode(ONEW_mode_romzen,ONEW_menu_zenkaku1);
		ch = ONEW_getch0(1);
		ONEW_kanamode = omode;
	}
	ONEWromkan_zenkaku(ch,buf);
	for( bp = buf; *bp; bp++ )
		enq_keyinQ(*bp);
	if( kakutei )
		enq_keyinQ(KAKUTEI);
}
ONEWromkan_zenkaku(ch,dst)
	char *dst;
{	char *tab,*jis;

	if( 0x200 <= ch ){
		dst[0] = ch;
		dst[1] = 0;
	}else{
		jis = &ONEW_ASCII_TO_JIS[ch*2];
		dst[0] = jis[0];
		dst[1] = jis[1];
		dst[2] = 0;
	}
}

Onew_HENKANKEYS(syms)
	char *syms;
{
	setA(syms,ONEW_HENKANKEYA,"ONEW_HENKANKEYS",
		ONEW_HENKANKEYS,0);
}
Onew_THRUSYMS(syms)
{
	setA(syms,ONEW_THRUSYMA,"ONEW_THRUSYMS",
		ONEW_THRUSYMS,&ONEW_THRUSYMS_ON);
}
static setA(syms,syma,envn,defv,flag)
	char *syms,*syma,*envn,*defv;
	int *flag;
{	int  ch;
	char chs[2];
	char rexp[1024];

	if( syms == 0 ){
		if( syms = getenv(envn) ){
			if(flag) *flag = 1;
		}else	syms = defv;
	}

	if( *syms == '[' )
		re_comp(syms);
	else{
		sprintf(rexp,"[%s]",syms);
		re_comp(rexp);
	}
	chs[1] = 0;
	for(ch = 1; ch < 128; ch++){
		chs[0] = ch;
		if( re_exec(chs) == 1 )
			syma[ch] = 1;
		else	syma[ch] = 0;
	}
}
static char *thrusyms(syms)
	char *syms;
{	int ch;
	char *chp;

	chp = syms;
	for(ch = 1; ch < 128; ch++){
		if( ONEW_THRUSYMA[ch] ){
			if( 0x20 <= ch )
				*chp++ = ch;
			else{
				*chp++ = '^';
				*chp++ = ch + 0x40;
			}
		}
	}
	*chp = 0;
	return syms;
}
static set_thruchar(){
	int kc,on;
	char syms[256];

	if( !ready_keyinQ() )
		putmode(romkan_cmode(),
			ONEW_THRUSYMS_ON?ONEW_menu_thruOFF:ONEW_menu_thruON);
	kc = asis_romkan_next();

	Onew_disp_kanahalf(' ');
	if( kc == THRUSYMS_SETUP )
		sym_thru_toggle();
	else{
		for(;;){
			if( kc == ESC_CH || kc == '\r' )
				break;
			if( kc == THRUSYMS_SETUP ){
				sym_thru_toggle();
				break;
			}
			on = ONEW_THRUSYMA[kc] = !ONEW_THRUSYMA[kc];
			putmsg(1,ONEW_menu_thruSET, 0x20 <= kc?kc:' ',
				on?"ON":"OFF",thrusyms(syms));
			kc = asis_romkan_next();
		}
	}
}

static Linebuff kana_inbuff;
Onew_deqchar(commandmode){
	int ch;

	if( ch = deq_strq(kana_inbuff) )
		return ch;
	if( commandmode || ONEW_RK_THRU )
		if( 0 < Onew_inready(stdin,-1) )
			return OnewGetchar();
	return 0;
}
Onew_enqchar(ch){
	enq_strq(kana_inbuff,ch);
}
Onew_enqstr(str) char *str; {
	char *sp,ch;
	for(sp = str; ch = *sp; sp++)
		Onew_enqchar(ch);
}

static asis_romkan_next(){
	int kc;

	get_ch1_asis = 1;
	kc = ONEWromkan_next();
	get_ch1_asis = 0;
	return kc;
}


static int ROMKAN_INIT_DONE;
Onew_RK_init(){
	char *env;

	if( ROMKAN_INIT_DONE == 0 ){
		if( env = getenv("ONEW_MSGHOLD") )
			ONEW_MSGHOLD = atoi(env);
		Onew_HENKANKEYS(0);
		Onew_THRUSYMS(0);
		ONEW_NN_THRU    = getenv("ONEW_NN_THRU")    != 0;
		ONEW_IN_ISO2022 = getenv("ONEW_NO_ISO2022") == 0;
		ONEW_DEBUG      = getenv("ONEW_DEBUG")      != 0;

		ROMKAN_INIT_DONE = romkan_ready();
		keisen_init();
	}
	return 0 < ROMKAN_INIT_DONE;
}
static int kanakan_mode;
kget_char1(){
	unsigned int kc;

	if( !Onew_RK_init() ){
		kc = OnewGetchar();
		return kc;
	}
start:
	if( kc = Onew_deqchar(0) ){
		return kc;
	}

	if( ONEW_RK_THRU ){
		kc = OnewGetchar();
		return kc;
	}

	do{
		if( romkan_on() )
			kc = ONEWromkan_getc();
		else	kc = ONEWromkan_next();

		if( romkan_on() )
		if( kc=='\r' || kc=='\n' || kc==KAKUTEI ){
			if( Onew_kakutei(kc) )
				goto start;
			if( kc==KAKUTEI )
				goto start;
		}

		if( romkan_on() && IS_NOINS_HENKANKEY(kc) ){
			if( !kanakan_ready() )
				goto start;

			kanakan_mode = 1;
			kc = ONEW_KANAKAN(kc);
			kanakan_mode = 0;

			if( kc == ONEW_HENKAN_START ){
				/* maybe q-a for empty buffer */
				goto start;
			}
			if( kc == STD_HENKAN ){
				if( ONEW_THRUSYMS_ON && ONEW_THRUSYMA[kc] )
					enq_keyinQ(KAKUTEI);
				else{
					ins_zenkaku_char1(kc,1);
					goto start;
				}
			}
		}else
		if( kc == THRU_NEXTCHAR || kc == THRU_NEXTCHAR_I ){
			int vkc,omode;

			if( !ready_keyinQ() )
				Onew_disp_kanahalf('^');

			vkc = kc;
			omode = ONEWromkan_modesw(0);
			if( kc == THRU_NEXTCHAR ){
				enq_keyinQ(SYNC_CHAR_I);
				asis_romkan_next();
				putmode(romkan_cmode(),ONEW_menu_thru1);
			}
			kc = asis_romkan_next();
			ONEWromkan_modesw(omode);

			if( kc == THRUSYMS_SETUP ){
				set_thruchar();
				continue;
			}else{
				if( vkc == THRU_NEXTCHAR )
					Onew_enqchar(vkc);
				Onew_enqchar(kc);
			}
			goto start;
		}else
		if( romkan_on() && kc == Cntl('G') ){
			wchar code[2];

			if( get_jisspecial(code) )
				Onew_enqstr(code);
			goto start;
		}else{
			kc = ONEWromkan_gotch(kc);
			if( kc == 0 )
				continue;
			if( kc == ESCESC ){
				if( abort_touroku() )
					goto start;
				kc = ESC_CH;
			}
			if( in_kana_mode() )
			if( ONEW_THRUSYMS_ON ){
				/* enqueue kakutei control code if
				   there has been no JIS input */
				/*enq_keyinQ(KAKUTEI);*/
			}else{
				if( ' ' < kc  && kc < 0x7F && !isalpha(kc) ){
					ins_zenkaku_char1(kc,0);
					kc = 0;
					continue;
				}
			}

			if(kc & 0xFF00)
			if(kc && 0x80){
				Linebuff buff;
				ONEW_GOT_2BCHAR(buff,kc>>8,kc&0xFF);
				Onew_enqstr(buff);
				goto start;
			}else	kc = (kc >> 8) & 0xFF;
		    }
	}while(kc == 0);

	if( !romkan_on() && (kc & 0x80) && (kc != EOF) )
		/* ??? */ goto start;

	return kc;
}
Onew_romkan(){
	return kget_char1();
}

wchar *
nth_jiscode(arg,n,code)
	wchar *code;
{	Uchar *ncode = (Uchar*)code;

	n++;
	ncode[0] = 0xA1 + n / 0x60;
	ncode[1] = 0xA0 + n % 0x60;
	code[1] = 0;

	/* the first and the last char in the KU */
	if( n % KU_SIZE == 0 || n % KU_SIZE == 0x5F )
		return 0;
	else	return code;
}
static ku_label(label,from,to,max)
	char *label;
{	wchar code[2];
	Uchar *ncode = (Uchar*)code;
	int hi,lo;

	nth_jiscode(0,from,code);
	hi = ncode[0];
	lo = ncode[1];
/*
	sprintf(label,"%02d%02d %02x%02x",hi-0xA0,lo-0xA0,hi,lo);
*/
	sprintf(label,"[%02d%02d]",hi-0xA0,lo-0xA0);
}
static ku_error(com){
	ONEW_BEEP(0);
	putmsg(1,"%s",ONEW_menu_jiscode);
	OnewGetchar();
}

static get_jisspecial(code)
	wchar *code;
{	int n;
	static int curtop = 0;

	int NCODES = 0x60*84 - 16*4; /*84th-KU fragment*/
	
	select_mode = 1;
	putmode(ONEW_mode_kuten,"");
	if( n = Onew_list_sentaku(ku_label,ku_error,
		nth_jiscode,0,NCODES,KU_SIZE,&curtop) ){
		if( nth_jiscode(0,n,code) == 0 )
			code[0] = 0xA1A1;
	}
	select_mode = 0;
	return n;
}

/*######################################################################*
 *	Romaji-Kana henkan MODE SWITCH					*
 *######################################################################*/
/*
 *	MODE FLAGS
 */
int ONEW_kanamode;

romkan_on(){
	return ONEW_kanamode;
}
Onew_RK_imode(){
	return romkan_on();
}
Onew_RK_imode_setv(imode)
{
	ONEW_kanamode = imode;
}
romkanmode_ch(){
	switch( ONEW_kanamode ){
		case ZENKAKU:		return RK_HIRA;
		case ZENKAKU|KATAKANA:	return RK_KATA;
		case ZENKAKU| NOTKANA:	return RK_LARGE;
		default:		return RK_THRU;
	}
}
Onew_RK_cmode(){
	return romkanmode_ch();
}

Onew_RK_imode_set(imode)
{
	return ONEWromkan_modesw(imode);
}

romkan_mode_switch(mode){
	int new_kana_mode = 0;

	switch( mode ){
		default : new_kana_mode = 0; break;
		case RK_HIRA:  new_kana_mode = ZENKAKU; break;
		case RK_KATA:  new_kana_mode = ZENKAKU | KATAKANA; break;
		case RK_LARGE: new_kana_mode = ZENKAKU | NOTKANA; break;
		case RK_THRU:  new_kana_mode = 0; break;
	}
	if( ONEW_kanamode && new_kana_mode )
		ONEWromkan_modesw(0);
	ONEWromkan_modesw(new_kana_mode);
}
Onew_RK_cmode_set(mode){
	Onew_RK_init();
	return romkan_mode_switch(mode);
}
romkan_toggle(){
	if( ONEW_kanamode )
		ONEWromkan_modesw(0);
	else	ONEWromkan_modesw(ZENKAKU);
}
Onew_RK_toggle(){
	return romkan_toggle();
}
zenkaku_toggle(){
	if( ONEW_kanamode & ZENKAKU ){
		ONEWromkan_modesw( ONEW_kanamode ^ NOTKANA );
	}
}
sym_thru_toggle(){
	ONEW_THRUSYMS_ON = !ONEW_THRUSYMS_ON;
}

in_kana_mode(){
	int Kmode,ki,mode;

	if(	ONEW_kanamode == ZENKAKU
	     || ONEW_kanamode ==(ZENKAKU|KATAKANA) )
		return 1;
	for( ki = 0; ki < kanamodex; ki++ )
		if( ONEW_kanamode == kanamodes[ki] )
			return 1;
	return 0;
}
katakana_toggle(){
	if( in_kana_mode() ){
		ONEW_kanamode &= (ZENKAKU | KATAKANA);
		ONEWromkan_modesw(ONEW_kanamode ^ KATAKANA);
		return 1;
	}
	return 0;
}

char *
ONEWromkan_smode(){
	static char rkmode[8];

	if(ROMKAN_INIT_DONE && ONEW_kanamode)
		sprintf(rkmode,ONEWromkan_dispmode(),rkEngineID());
	else	strcpy(rkmode,"[---]");

	if( ONEW_THRUSYMS_ON )
	if( rkmode[4] == ']' )
		strcpy(&rkmode[4],"-]");

	return rkmode;
}
char *Onew_RK_smode(){
	return ONEWromkan_smode();
}
char *romkan_cmode(){
	return Onew_RK_smode();
}

char *romkan_help(){
	if( romkan_on() )
		return ONEW_menu_romkana;
	else	return ONEW_menu_roman;
}

char PADD_CHAR = 0x7F;
Uchar *
ToLocalString(dst,src,wlen)
	wchar *dst;
	Uchar *src;
{	int si;

	for(si = 0; si < wlen; si++){
		if( src[si*2] )
			dst[si] = src[si*2] << 8 | src[si*2+1];
		else	dst[si] = PADD_CHAR << 8 | src[si*2+1];
	}
	dst[si] = 0;
	return (Uchar*)&dst[si];
}

/*######################################################################*
 *	KANA-KAN							*
 *######################################################################*/
Onew_kanakan(com,str,start,leng)
{
	return Onew_kana_to_kanji(com,str,start,leng);
}

char ONEW_CurrentYomi[256];
char ONEW_CurrentKanji[1024];
Uchar ONEW_DicYomi[256];

Onew_kana_to_kanji(startcom,str)
	Uchar *str;
{	Uchar buf[1024];
	Uchar sstr[2048];
	int endcom;

	if( JisyoGetYomi && startcom != STD_HENKAN ){
		if( start_touroku(str) )
			JisyoGetYomi = 0;
		return 0;
	}
	if( JisyoGetKanjiFlush ){
		strcpy(ONEW_CurrentKanji,str);
		JisyoGetKanjiFlush = 0;
		jisyo_touroku();
		str = ONEW_DicYomi;
	}
	if( Onew_non_ascii(str) == 0 ){
		if( ONEW_THRUSYMS_ON && ONEW_THRUSYMA[startcom] )
			sprintf(buf,"%s%c",str,startcom);
		else	strcpy(buf,str);
		ONEW_DISP_KANAKANB(0,buf,"","");
		ONEW_KAKUTEI(KAKUTEI);
		return 0;
	}

	strcpy(sstr,str);
	strcpy(ONEW_CurrentYomi,sstr);

	for(;;){
		endcom = ONEWkanakan(startcom,str);
		if( endcom == ONEW_RKKSERV_SW ){
			switch_kkserv();
			str = sstr;
			continue;
		}
		if( endcom == KK_OPDICT || endcom == 'q' ){
			if( jisyo_sousa() ){
				endcom = 0;
				break;
			}else{
				str = sstr;
				continue;
			}
		}
		if( endcom != BS_CH && endcom != DEL_CH ){
			if( JisyoGetYomi ){
				if( start_touroku(ONEW_CurrentKanji) ){
					JisyoGetYomi = 0;
					break;
				}
			}
			if( JisyoGetKanji ){
				jisyo_touroku();
				strcpy(sstr,ONEW_DicYomi);
				str = sstr;
				continue;
			}
		}
		break;
	}
	ONEW_CurrentKanji[0] = 0;
	return endcom;
}

static start_touroku(yomi)
	char *yomi;
{
	if( yomi[0] == 0 )
		return 0;

	strcpy(ONEW_DicYomi,yomi);
	ONEW_DISP_KANAKANB(0,"","","");
	JisyoGetKanji = 1;
	return 1;
}
static abort_touroku(){
	if( JisyoGetYomi || JisyoGetKanji || JisyoGetKanjiFlush ){
		putmsg(1,ONEW_msg_tourokuABORT);
		ONEW_BEEP(2);
		JisyoGetYomi = 0;
		JisyoGetKanji = 0;
		JisyoGetKanjiFlush = 0;
		return 1;
	}
	return 0;
}
static jisyo_sousa(){
	int com;

	JisyoMode = 1;
	putmode(ONEW_mode_jisyo,ONEW_menu_jisyo);
	JisyoMode = 0;

	com = ONEW_getch0(1);
	if( com == 'a' ){
		return start_touroku(ONEW_CurrentKanji);
	}
	if( com == 'd' ){
		jisyo_massyou();
		return 0;
	}
	return 0;
}

static jisyo_massyou()
{
	JisyoMassyou = 1;
	putmode(ONEW_mode_massyou,ONEW_menu_massyou);
	if( ONEW_getch0(1) == 'y' )
		ONEWjisyo_touroku(0,0,ONEW_CurrentYomi,ONEW_CurrentKanji);
	JisyoMassyou = 0;
}

Onew_kakutei(kc)
{	int kakutei;

	if( JisyoGetYomi ){
		enq_keyinQ(ONEW_HENKAN_START);
		return 1;
	}
	if( JisyoGetKanji ){
		if( ONEW_CurrentKanji[0] == 0 ){
			JisyoGetKanjiFlush = 1;
			enq_keyinQ(ONEW_HENKAN_START);
			return 1;
		}
		jisyo_touroku();
	}
	kakutei = ONEW_KAKUTEI(kc);
	return kakutei;
}

static jisyo_touroku()
{	int i,max;
	int com;
	Hinshi *hinshi;
	char hname[128],kanji[1024];

	if( ONEWjisyo_hinshi(&hinshi) == 0 )
		return;

	JisyoGetKanji = 0;
	putmode(ONEW_mode_hinshi,"");

	for( max = 0; hinshi[max].name; max++)
		;
	i = 0;
	sprintf(kanji,"(%s)[%s]",ONEW_DicYomi,ONEW_CurrentKanji);
	for(;;){
		sprintf(hname,"<%s>",hinshi[i].name);
		ONEW_DISP_KANAKANB(1,kanji,hname,"");

/* this should be after above to flush jvim screen ? */
putmsg(1,"[%d/%d] %s",i+1,max,ONEW_menu_touroku);

		switch( com = getchar() ){
			case ESC_CH:
				ONEW_DISP_KANAKANB(0,ONEW_DicYomi,"","");
				goto exit;

			case ' ': i++; if(hinshi[i].name==0) i = 0; break;
			case Cntl('P'):
			case 'b': i--; if(i < 0) i = max-1; break;
			case '\r':
			case '\n': goto out;
		}
	}
out:
	ONEW_DISP_KANAKANB(0,ONEW_DicYomi,"","");
	ONEWjisyo_touroku(1,hinshi[i].code,ONEW_DicYomi,ONEW_CurrentKanji);
exit:
	JisyoGetKanji = 0;
}

Onew_dispKanakanBuf(so,left,cur,right)
	char *left,*cur,*right;
{	char xleft[1024],xright[1024];

	Onew_rmpadds(left);
	Onew_rmpadds(cur);
	Onew_rmpadds(right);

	sprintf(ONEW_CurrentKanji,"%s%s%s",left,cur,right);
	if( so && JisyoGetKanji ){
		sprintf(xleft,"[%s",left);
		left = xleft;
		sprintf(xright,"%s]",right);
		right = xright;
	}
	ONEW_DISP_KANAKANB(so,left,cur,right);
}

Onew_setupYomistr(com,str,yomibuf)
	char *str,*yomibuf;
{	int len;
	int lastch;

	strcpy(yomibuf,str);
	if( ONEW_THRUSYMS_ON && com != STD_HENKAN )
	if( len = strlen(str) ){
		lastch = str[len-1];
		if( ONEW_THRUSYMA[lastch] )
			strcat(yomibuf," ");
	}
}

Onew_freqsave(){
	ONEWkanakan_freqsave();
}
Onew_KK_freqsave(){
	return Onew_freqsave();
}

/*######################################################################*
 *	FILL/STRIP THE "kana_buf" WITH PADDING				*
 *######################################################################*/
ToServerString(str,wp)
	Uchar *str;
	wchar *wp;
{	Uchar *s;

	for(s = str; s[0]; ){
		if(s[0] & 0x80){
			if(s[1] == 0)
				break;
			*wp++ = (s[0] << 8) | s[1];
			s += 2;
		}else{
			while( s[0] && !(s[0] & 0x80) )
			   if( s[1] && !(s[1] & 0x80) ){
				*wp++ = (s[0] << 8) | s[1];
				s += 2;
			   }else{
				*wp++ = (s[0] << 8) | PADD_CHAR;
				s++;
				break;
			   }
			if( s[0] )
				*wp++ = (PADD_CHAR << 8) | PADD_CHAR;

		}
	}
	*wp = wp[1] = wp[2] = 0;
}
Onew_rmpadds(str)
	Uchar *str;
{	Uchar *cp;

	for(cp = str; *cp; ){
		if(*cp == PADD_CHAR)
			strcpy(cp,cp+1);
		else	cp++;
	}
	cp[1] = 0;
}

/*######################################################################*
 *	MISC								*
 */
static Linebuff LASTMSG;
static Linebuff LASTMODE;
static int LASTMODEF;

static onew_mode(){
	int mode;

	mode = ONEW_kanamode
	     | (ONEW_INCHAR_WIDTH==2 ? KF_2BINPUT  : 0)
	     | (ONEW_THRUSYMS_ON     ? KF_THRUSYMS : 0)
	     | (ONEW_NN_THRU         ? KF_NN_THRU  : 0)
	     | (get_ch1_asis         ? KF_NEXTCHAR : 0)
	     | (select_mode          ? KF_SELECT   : 0)
	     | (kanakan_mode         ? KF_KANAKAN  : 0)
	     | (JisyoMode            ? KF_JISYO    : 0)
	     | (JisyoGetYomi         ? KF_GETYOMI  : 0)
	     | (JisyoGetKanji        ? KF_GETKANJI : 0)
	     | (JisyoMassyou         ? KF_MASSYOU  : 0);
	return mode;
}
static putmode(mode,help)
	char *mode,*help;
{	int modeflags;
	char xmode[128];
	char xhelp[512];
/*
if( input_ready() ) return;
*/
	modeflags = onew_mode();
	if( mode == 0 ) mode = Onew_RK_smode();
	if( help == 0 ) help = romkan_help();

	if( JisyoGetYomi ){
		sprintf(xmode,"%s%s",ONEW_mode_touroku_yomi,mode);
		mode = xmode;
	}
	if( JisyoGetKanji ){
		sprintf(xmode,"%s%s",ONEW_mode_touroku_kanji,mode);
		mode = xmode;
		sprintf(xhelp,"(%s) %s",ONEW_DicYomi,help);
		help = xhelp;
	}
	ONEW_DISP_ROMKANMODE(mode,help,modeflags);

	if( strcmp(LASTMODE,mode) != 0 ){
/*
	if( modeflags != LASTMODEF ){
*/
		LASTMODEF = modeflags;
		strcpy(LASTMODE,mode);
		/* clear the mirror of status line since the real status
		 * message will be rewrote on the status change.
		 */
		LASTMSG[0] = 0;
	}
}
Onew_putmode(mode,help){
	putmode(mode,help);
}
Onew_putmodef(mode,fmt,a,b,c,d,e,f,g)
{	char help[1024];
	sprintf(help,fmt,a,b,c,d,e,f,g);
	putmode(mode,help);
}
Onew_curmsg(msg)
	char *msg;
{
	strcpy(LASTMSG,msg);
}

putmsg(so,F,a,b,c,d,e,f,g)
{	Linebuff tmsg,msg;
	Uchar *mp;
	int maxcol = ONEW_MESSAGE_COLS();

	sprintf(tmsg,F,a,b,c,d,e,f,g);

	sprintf(msg,"%s%*s",so?" ":"",-maxcol,tmsg);
	msg[maxcol-1] = 0;

	for(mp = msg; *mp; ){
		if( *mp & 0x80 ){
			if(mp[1] == 0 ){
				*mp = 0;
				break;
			}else	mp += 2;
		}else	mp++;
	}

	if( strcmp(LASTMSG,msg) )
	{
		ONEW_MESSAGE(so,"%s",msg);
		strcpy(LASTMSG,msg);
	}
}

static strq_overflow(len){
	if( (sizeof(Linebuff)-1) <= len ){
		ONEW_MESSAGE(1,"input buffer overflow!! (%d)",len);
		ONEW_BEEP(5);
		return 1;
	}
	return 0;
}
enq_strq(Q,c)
	Uchar *Q,c;
{	int len;

	if( strq_overflow(len=strlen(Q)) )
		return;
	Q[len] = c;
	Q[len+1] = 0;
}
ins_strq(Q,c)
	Uchar *Q,c;
{	Linebuff buff;
	int len;

	if( strq_overflow(len=strlen(Q)) )
		return;
	strcpy(buff,Q);
	Q[0] = c;
	strcpy(&Q[1],buff);
}
deq_strq(Q)
	Uchar *Q;
{	int i,c;

	if( c = Q[0] ){
		strcpy(Q,Q+1);
		return c;
	}
	return 0;
}
clr_strq(Q)
	Uchar *Q;
{
	Q[0] = 0;
}


/*
 *	INPUT CODE HANDLER (external code to internal code translation)
 *	problem: how to treat 2B input in "command" mode ...??
 */
static GETCHAR(){
	int ch;
	static int N0,N1;

	if( ONEW_DEBUG ){
		fprintf(stderr,"\n\r[%d] ONEW_GETCHAR(): watining... ",++N0);
		fflush(stderr);
	}

	ch = ONEW_GETCHAR();

	if( ONEW_DEBUG ){
		alarm(0);
		fprintf(stderr,"\n\r[%d] got: %x",++N1,ch);
		fflush(stderr);
		sleep(1);
	}
	return ch;
}

static input_ready(){
	int msec;
	msec = 1;
	ONEW_PEEKCHAR(&msec);
	return 0 <= msec;
}

OnewGetchar(){
	int ch,nch;
	int rmsec;

	ch = GETCHAR();
	if( ONEW_IN_ISO2022 ){
		if( ch == ESC_CH ){
			rmsec = ONEW_ESC_TIMEOUT;
			nch = ONEW_PEEKCHAR(&rmsec);
			if( rmsec < 0 ){
				;/* TIMEOUT */
			}else
			if( nch == '$' || nch == '(' ){
				GETCHAR(); /* flush '$','(' */
				GETCHAR();
				if( nch == '$' ){
					ONEW_INCHAR_NTH = 0;
					ONEW_INCHAR_WIDTH = 2;
					putmode(ONEW_mode_2Bchar,0);
				}else{
					ONEW_INCHAR_WIDTH = 1;
					putmode(0,0);
				}
				return OnewGetchar();
			}
		}
		if( ONEW_INCHAR_WIDTH == 2 ){
			if( 0x20 < ch && ch < 0x7F ){
				ch |= 0x80;
				if( 2 <= ++ONEW_INCHAR_NTH )
					ONEW_INCHAR_NTH = 1;
			}else{
				ONEW_INCHAR_WIDTH = 1;
				putmode(0,0);
				if( ONEW_INCHAR_NTH != 0 )
					ch = 0xA1; /* padding */
			}
		}
	}
	return ch;
}

Onew_RK_thru(mode){
	ONEW_RK_THRU = mode;
}


Onew_inready( fp, wait_usec )
	FILE *fp;
{
	if( *rawc_inbuff || *kana_inbuff )
		return 1;
	return Onew_fp_input_ready(fp,wait_usec);
}

Onew_disp_kanahalf(ch)
{	char buf[128];

	buf[0] = ch;
	buf[1] = 0;
	Onew_disp_kanahalves(buf);
}
Onew_disp_kanahalves(str)
{
	ONEW_DISP_KANAHALVES(str);
}


/*
 *	OBSOLETE
 */
kana_init(){
	return Onew_RK_init();
}
kana_to_kanji(str,start,leng)
{
	return Onew_kana_to_kanji(0,str,start,leng);
}

